
/*
     ______     __                     ___     __
    /\  _  \   /\ \                   /\_ \   /\_\
    \ \ \_\ \  \ \ \      __     ___  \//\ \  \/_/_
     \ \  __ \ `/__ \   /'__`\  / __`\  \ \ \   /\ \
      \ \ \/\ \/\\_\ \_/\ \_\ \/\ \_\ \_ \_\ \_ \_\ \_
       \ \_\ \_\ \_____\ \___\ \ \______\/\____\/\____\
        \/_/\/_/\/_____/\/___L\ \/______/\/____/\/____/
                          /\____/
                          \_/__/




                  An advanced game library

                 (c) Stephane APIOU 2003


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



*/
typedef struct _symb
{
	char name[30];
	agl_elemtype val;
	struct _symb *pnext;
} agl_gramsymb;

struct _agl_analyse;

#define	AGL_GRAMNONE	0
#define	AGL_GRAMVAL	1
#define	AGL_GRAMSYMB	2
#define	AGL_GRAMKEYW	3
#define	AGL_GRAMINSTR	4
#define	AGL_GRAMLSTSZ	5
#define	AGL_GRAMMOD	6
#define	AGL_GRAMDEFN	7

typedef struct _instr
{
	union
	{
		agl_elemtype val;
		agl_gramsymb *symb;
		agl_moddefn *defn;
		agl_modelem *keyw;
		agl_module *mod;
		int (*instr) (struct _agl_analyse *);
		long lstsz;
	} u;
	int type;
	struct _instr *pnext;
	struct _instr *pgnext;
} agl_graminstr;

typedef struct _agl_analyse
{
	agl_gramsymb *symlist;

	agl_graminstr *garblist;

	agl_graminstr *codelist;
	agl_graminstr *codeptr;

	agl_graminstr *stacklist;

	agl_module *pmodule;

	agl_module *curmodule;

	agl_gramsymb *cursymb;

	int lineno;
	agl_ios *ops;
} agl_analyse;

extern agl_graminstr *agl_gramencode(agl_analyse * analyse, agl_graminstr * f);
extern int agl_keywstmt2(agl_analyse *);
extern int agl_keywlike(agl_analyse *);
extern int agl_keywadd(agl_analyse *);
extern int agl_keywend(agl_analyse *);
extern int agl_keywassign(agl_analyse *);
extern int agl_ieval(agl_analyse *);
extern int agl_valpush(agl_analyse *);
extern int agl_listcrnpush(agl_analyse *);
extern int agl_indicescrnpush(agl_analyse *);
extern int agl_gramhash(agl_analyse *);
extern int agl_keywindex(agl_analyse *);
extern int agl_gramparse(agl_handle, agl_ios *);
extern int agl_gramaddmod(agl_analyse *, agl_module *);
extern int fntinit(agl_analyse *);

#define GRAM_NONE	((int (*)(agl_analyse *))0)
