
/*
     ______     __                     ___     __
    /\  _  \   /\ \                   /\_ \   /\_\
    \ \ \_\ \  \ \ \      __     ___  \//\ \  \/_/_
     \ \  __ \ `/__ \   /'__`\  / __`\  \ \ \   /\ \
      \ \ \/\ \/\\_\ \_/\ \_\ \/\ \_\ \_ \_\ \_ \_\ \_
       \ \_\ \_\ \_____\ \___\ \ \______\/\____\/\____\
        \/_/\/_/\/_____/\/___L\ \/______/\/____/\/____/
                          /\____/
                          \_/__/




                  An advanced game library

                 (c) Stephane APIOU 2003


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



*/

#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "agl_private.h"

agl_font *
agl_fontioload(agl_ios * ops, int size)
{
	agl_module *ptr;
	agl_fontio *pio;
	int recognised;
	long cur_pos;
	agl_font *font;
	agl_container *handle;

	agl_rvassert(ops != NULL, NULL);


	font = NULL;
	if ((cur_pos = agl_ios_tell(ops)) < 0)
	{
		agl_error("can't load font");
		return NULL;
	}
	handle = ops->handle;
	for (ptr = handle->moduleroot; ptr; ptr = ptr->pnext)
	{
		if (ptr->type == AGL_MOD_FONT)
		{
			pio = (agl_fontio *) ptr->priv_desc;
			recognised = pio->is(ptr, ops);
			if (agl_ios_seek(ops, cur_pos, SEEK_SET) < 0)
			{
				agl_error("can't load font");
				return NULL;
			}
			if (recognised)
			{
				font = pio->open(ptr, ops, size);
				break;
			}
		}
	}
	if (font == NULL)
	{
		agl_error("can't load font");
		return NULL;
	}
	return font;
}
