
/*
     ______     __                     ___     __
    /\  _  \   /\ \                   /\_ \   /\_\
    \ \ \_\ \  \ \ \      __     ___  \//\ \  \/_/_
     \ \  __ \ `/__ \   /'__`\  / __`\  \ \ \   /\ \
      \ \ \/\ \/\\_\ \_/\ \_\ \/\ \_\ \_ \_\ \_ \_\ \_
       \ \_\ \_\ \_____\ \___\ \ \______\/\____\/\____\
        \/_/\/_/\/_____/\/___L\ \/______/\/____/\/____/
                          /\____/
                          \_/__/




                  An advanced game library

                 (c) Stephane APIOU 2003


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



*/

//! this is an image loading module. This module is generic and requires specific files modules

/*!\file agl_imageio.c
 * \ingroup video
 * internals.
 * \author Stephane APIOU
 */

#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "agl_private.h"

agl_image *
agl_imgioload(agl_ios * ops)
{
	agl_module *ptr;
	agl_imgio *pio;
	int recognised;
	long cur_pos;
	agl_image *img;
	agl_container *handle;

	agl_rvassert(ops != NULL, NULL);

	handle = ops->handle;

	img = NULL;
	if ((cur_pos = agl_ios_tell(ops)) < 0)
	{
		agl_error("can't load image");
		return NULL;
	}
	for (ptr = handle->moduleroot; ptr; ptr = ptr->pnext)
	{
		if (ptr->type == AGL_MOD_IMG)
		{
			pio = (agl_imgio *) ptr->priv_desc;
			recognised = pio->is(ops);
			if (agl_ios_seek(ops, cur_pos, SEEK_SET) < 0)
			{
				agl_error("can't load image");
				return NULL;
			}
			if (recognised)
			{
				img = pio->load(ops);
				break;
			}
		}
	}
	if (img == NULL)
	{
		agl_error("can't load image");
		return NULL;
	}
	/* SA a corriger
	 * if (ops->filename != NULL)
	 * {
	 * img->image_name = agl_malloc(strlen(ops->filename) + 1);
	 * if (img->image_name == NULL)
	 * {
	 * agl_memerr();
	 * agl_imgfree(img);
	 * return NULL;
	 * }
	 * strcpy(img->image_name, ops->filename);
	 * img->alpha_name = agl_malloc(strlen(ops->filename) + 1);
	 * if (img->alpha_name == NULL)
	 * {
	 * agl_memerr();
	 * agl_imgfree(img);
	 * return NULL;
	 * }
	 * strcpy(img->alpha_name, ops->filename);
	 * }
	 */
	return img;
}
