
/*
     ______     __                     ___     __
    /\  _  \   /\ \                   /\_ \   /\_\
    \ \ \_\ \  \ \ \      __     ___  \//\ \  \/_/_
     \ \  __ \ `/__ \   /'__`\  / __`\  \ \ \   /\ \
      \ \ \/\ \/\\_\ \_/\ \_\ \/\ \_\ \_ \_\ \_ \_\ \_
       \ \_\ \_\ \_____\ \___\ \ \______\/\____\/\____\
        \/_/\/_/\/_____/\/___L\ \/______/\/____/\/____/
                          /\____/
                          \_/__/




                  An advanced game library

                 (c) Stephane APIOU 2003


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



*/

//! this is a general font structure module

/*!\file agl_font.c
 * \ingroup video
 * internals.
 * \author Stephane APIOU
 */

#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "agl_private.h"

agl_font *
agl_fontnew(void)
{
	agl_font *font;
	int i;

	font = (agl_font *) agl_malloc(sizeof(agl_font));
	if (font == NULL)
	{
		agl_memerr();
		return NULL;
	}

	for (i = 0; i < 256; i++)
		font->glyphs[i].created = 0;

	font->height = 0;
	font->ascent = 0;
	font->descent = 0;
	font->linegap = 0;
	font->priv = NULL;
	font->pfio = NULL;

	return (font);
}

int
agl_fontfree(agl_font * font)
{
	agl_rvassert(font != NULL, -1);

	if (font->pfio != NULL)
		if (font->pfio->close(font) < 0)
			return -1;
	agl_free(font);
	return 1;
}
